'\"
'\" Soar man page 
'\"
.so man.macros
.HS help soar
.BS
'\" Note:  do not modify the .SH NAME line immediately below!
.SH NAME
help \- Print man pages for Soar commands
.SH SYNOPSIS
\fBhelp\fR [\fB-all\fR | \fIcommandname\fR [\fB-usage\fR]]
.BE

.SH DESCRIPTION
.PP
This command prints the formatted manual page for the given 
\fIcommandname\fR.  Soar's help facility is able to do command
completion, so as long as a unique substring of the commandname
is specified, Soar will find and display the help page.
.PP
Under the TSI (Tcl-Soar Interface, a graphical interface to Soar),
the \fBhelp\fR will pop up a separate window to display the text.
.PP
Under Unix with no TSI running, the \fBhelp\fR command attempts to
locate a pager program to
use to display help pages page-by-page since some are longer than a
typical screen.  The command first examines the environment 
variable PAGER to see if the user has defined a preference there.
If that is not present, the help system checks to see if one 
of the commonly used pagers "less", "more", or "page" is 
available (in that order).  If no pager is available, then 
an error message is given.  If no pagers exist on your system, 
then you can set the environment variable PAGER to "cat" and 
the help pages will simply be cat'ed to the screen.  Since
some pages are long, this will make it difficult to read an
entire page.

.SH OPTIONS
.TP
\fB-all\fR
List all commands for which help is available
.TP
\fB-usage\fR
List only the SYNOPSIS section of the man page.  This includes
the abbreviated syntax for the command.  -usage may not work properly
on some windows and mac systems.

.SH FILES
.PP
The nroff sources for the manual pages are stored in the 
subdirectory .../doc/man.  These files are used to
generate the "cat" and "HTML" versions which are stored
in .../doc/cat and .../doc/html, respectively.

.SH ENVIRONMENT
.TP
\fBPAGER\fR

This variable contains the user's preferred paging program
which shows text page by page rather than spewing all text at once
to standard output.  Typical pagers are \fBmore\fR, \fBless\fR, 
and \fBpage\fR.

.SH WARNINGS

Some pages, such as \fBless\fR clear the screen upon exit, removing
the help page from view.  If you wish to retain the help page, use
a pager such as \fBmore\fR.
