'\"
'\" Soar man page 
'\"
.so man.macros
.HS io soar
.BS
'\" Note:  do not modify the .SH NAME line immediately below!
.SH NAME
io \- Manage attachment of scripts to Soar I/O
.SH SYNOPSIS
\fBio\fR \fIaction\fR
.BE

.SH DESCRIPTION
.PP
This command manages the attachment of scripts to Soar I/O.  
Soar has an event defined for input and another for output.
Scripts can be attached to these Soar events so that they are
invoked every time the Soar event occurs.  
These scripts can later be removed using the \fBio\fR command.  
The status of attachments can be listed also.  If a new 
attachment is created, its identifier is returned as the result 
of this command.
.PP
The specified \fIaction\fR must have one of the following forms:
.TP
\fB\-add\fR [\fB-input\fR | \fB-output\fR] \fIscript [id]\fR
Add the \fIscript\fR to the list of scripts to be invoked when the
\fB-input\fR or \fBoutput\fR event occurs in the Soar kernel.  
If the \fIid\fR is given, it is used to name the attachment.  
If no \fIid\fR is given, then a unique id is generated and returned.
The id is necessary if a user ever wants to delete an action.
.TP
\fB\-delete\fR [\fB-input\fR | \fB-output\fR] \fIid\fR
Remove script attachment named \fIid\fR.
.TP
\fB\-list\fR [\fB-input\fR | \fB-output\fR]
List all attachments of scripts to Soar input or output.

.SH EXAMPLES
.PP
A detailed example of using Soar I/O in Tcl is given in the
file \fBdemos/soar-io-using-tcl.tcl\fR.
