'\"
'\" Soar man page 
'\"
.so man.macros
.HS max-chunks soar
.BS
'\" Note:  do not modify the .SH NAME line immediately below!
.SH NAME
max-chunks \- Set or list the maximum chunk count
.SH SYNOPSIS
\fBmax-chunks \fR[\fIcount\fR]
.BE

.SH DESCRIPTION
.PP
This command sets and prints the maximum number of chunks
that can be created in a single decision cycle.  If \fIcount\fR is
not given, this command
prints the maximum number of chunks that can be created.
If \fIcount\fR is given, it must be a positive integer and is used
to reset the number of chunks allowed.
.PP
The "max-chunks" parameter controls the maximum number of chunks 
that can be created in a single decision cycle.  After this limit
has been reached in a decision cycle, Soar proceeds to decision
phase even if quiescence hasn't really been reached yet.  The
default initial setting of the "max-chunks" parameter is 50.
.PP
In Soar8, chunks may be built during both the Propose Phase or
the Apply Phase.  If Soar8 builds more than the max-chunks limit in either
of these phases, Soar8 proceeds to the next phase (either Decision
or Output) even if quiescence has not been reached.  
.PP
If max-chunks are reached, and Soar moves on to the next phase,
a warning message is printed.
.SH EXAMPLES
.PP
The command issued with no arguments, returns the maximum chunk count:
.DS
\fBmax-chunks\fR 
.DE 
.PP
The next example makes use of Tcl command abbreviation while setting
the max-chunks to 100:
.DS
\fBmax-c  100\fR 
.DE


.SH VARIABLE
.PP
Note that the commandname uses dashes to separate the words.  There
is also a Soar variable "max_chunks" (with underscores)
that can be used to set the chunk limit through the the Tcl
\fIset\fR command.  If \fIcount\fR is not given, \fB'set max_chunks'\fR
prints the maximum number of chunks that can be created.
If \fIcount\fR is given, it must be a positive integer and is used
to reset the number of chunks allowed.

.SH SEE ALSO
\fBvariables\fR



