'\"
'\" Soar man page 
'\"
.so man.macros
.HS max-elaborations soar
.BS
'\" Note:  do not modify the .SH NAME line immediately below!
.SH NAME
max-elaborations \- Set or list the maximum elaborations allowed
.SH SYNOPSIS
\fBmax-elaborations \fR[\fIcount\fR]
.BE

.SH DESCRIPTION
.PP
This command sets and prints the maximum number of elaboration
cycles allowed.  If \fIcount\fR is not given, this command
prints the current number of elaboration cycles allowed.
If \fIcount\fR is given, it must be a positive integer and is used
to reset the number of allowed elaboration cycles.
.PP
The "max-elaborations" parameter controls the maximum number of
elaborations allowed in a single decision cycle.  After this limit
has been reached, Soar moves on to the next phase and 
a warning message is printed.  The
default initial setting of the "max-elaborations" parameter is 100.
.PP
In Soar8, max-elaborations is checked during both the Propose Phase and
the Apply Phase.  If Soar8 runs more than the max-elaborations limit in either
of these phases, Soar8 proceeds to the next phase (either Decision
or Output) even if quiescence has not been reached.  
.PP

.SH EXAMPLES
.PP
The command issued with no arguments, returns the max elaborations allowed:
.DS
\fBmax-elaborations\fR 
.DE 
.PP
The next example makes use of Tcl command abbreviation while setting
the maximum value to 50:
.DS
\fBmax-e  50\fR 
.DE

.SH VARIABLE
.PP
Note that the commandname uses dashes to separate the words.  There
is also a Soar variable "max_elaborations" (with underscores)
that can be used to set the limit through the the Tcl \fIset\fR
command.  If \fIcount\fR is not given, \fB'set max_elaborations'\fR
prints the current number of elaboration cycles allowed.
If \fIcount\fR is given, it must be a positive integer and is used
to reset the number of allowed elaboration cycles.


.SH SEE ALSO
\fBvariables\fR
