'\"
'\" Soar man page 
'\"
.so man.macros
.HS run soar
.BS
'\" Note:  do not modify the .SH NAME line immediately below!
.SH NAME
run \- Run Soar
.SH SYNOPSIS
\fBrun\fR [\fIn\fR | 'forever'] [\fIunit\fR] [-self]
.BE

.SH DESCRIPTION
.PP
This command runs the Soar agents. If the [-self] flag is issued, 
only the agent issuing the run command will run.  \fIn\fR is a single integer 
which specifies the number of times to run Soar.  If \fIn\fR is
unspecified and no \fIunit\fRs are given, OR if \fIn\fR 
is the single keyword '\fBforever\fR', then Soar is run  until halted 
by problem-solving completion or an external interrupt.  If \fIn\fR
is specified, but no \fIunit\fRs are specified, then soar is run
by decision cycles.  If \fIunit\fRs
are specified, but \fIn\fR is unspecified, then \fIn\fR defaults to '1'.  The
\fIunit\fR argument indicates the unit of measure to be used
in counting Soar run cycles.  \fIunit\fR must be one of the following
keywords:
.TP
\fBp\fR
run Soar for \fIn\fR phases.  A phase is either an input 
phase, preference phase, working memory phase, output 
phase, or decision phase.
.TP
\fBe\fR
run Soar for \fIn\fR elaboration cycles.  (For purposes of 
this command, decision phase is counted as an elaboration cycle.)
.TP
\fBd\fR
run Soar for \fIn\fR decision cycles
.TP
\fBs\fR
run Soar until the \fIn\fRth time a state is selected
.TP
\fBo\fR
run Soar until the \fIn\fRth time an operator is selected
.TP
\fBout\fR
run Soar until the \fIn\fRth time output is generated by the agent
.TP
\fB<s>\fR
run Soar until the current level of subgoaling has terminated
.TP
\fB<ss>\fR
run Soar until the superstate's level of subgoaling has terminated
.TP
\fB<sss>\fR
run Soar until the supersuperstate's level of subgoaling has terminated
.TP
\fB<o>\fR
run Soar until the \fIn\fRth time an operator is selected at this level of
subgoaling or until the current level of subgoaling is terminated.
.TP
\fB<so>\fR
run Soar until the \fIn\fRth time a superoperator is selected or until
that level of subgoaling is terminated.
.TP
\fB<sso>\fR
run Soar until the \fIn\fRth time a supersuperoperator is selected or until
that level of subgoaling is terminated.
.PP 
Unlike the Soar 6 \fIgo\fR command, \fIrun\fR has no memory of settings from
previous run commands.
.PP 
There are two predefined aliases for the run command, provided as a convenience
for use on the command line:
.TP
\fBd\fR [\fIn\fR]
run by decision cycles, equivalent to "run \fIn\fR d".  \fIn\fR defaults to 1.
.TP
\fBe\fR [\fIn\fR]
run by elaboration cycles, equivalent to "run \fIn\fR e".  \fIn\fR defaults to 1.


.SH EXAMPLES
.TP
\fBrun\fR
run all agents until halted by problem-solving completion or
an external interrupt is given.
.TP
\fBrun 5 d\fR
run all agents for 5 decision cycles
.TP
\fBrun d -self\fR
run the current agent only for 1 decision cycle
.TP
\fBrun 3\fR
run all agents for 3 decision cycles
.TP
\fBrun 2 e\fR
run all agents for 2 elaboration cycles
.TP
\fBrun 1 s\fR
run all agents until the next state is selected (i.e., 
until the next time an impasse arises)
.TP
\fBrun <so>\fR
run until the next superoperator is selected 
(or until the superstate goes away)
.TP
\fBrun 3 <o>\fR
run for 3 operator selections at this level 
(continuing through any subgoals that arise)

.SH WARNING
.PP
In Soar8, the preference phase is no longer separated from the
working memory phase, Soar continues right through from preferences
into working memory without stopping.  The phases
are Input, Propose, Decide, Apply, Output;  Propose and Apply each
consist of at least one, but possibly many,
preference/working-memory subphases.

.SH SEE ALSO
\fBd\fR, \fBe\fR, \fBstop-soar\fR, \fBpredefined-aliases\fR
