'\"
'\" Soar man page 
'\"
.so man.macros
.HS variables soar
.BS
'\" Note:  do not modify the .SH NAME line immediately below!
.SH NAME
Soar variables

.SH DESCRIPTION
.PP
There are a number of Soar variables that influence the 
behavior of Soar. These variables are given default values, 
which can be changed using the Tcl \fIset\fR command. However, unlike 
normal Tcl variables, Soar variables do have an enforced
type and can not be unset.
.PP
The defined Soar variables are:
.RS
.TP
\fBattribute_preferences_mode\fR [0|1|2]
The "attribute_preferences_mode" variable is used to control the
handling of preferences (other than acceptable and reject preferences).
.TP
\fBdefault_wme_depth\fR [0|1|2]
The "default_wme_depth" variable is used to control the
default printing depth of the \fBprint\fR command.
.TP
\fBmax_chunks\fR [positive integer]
The "max_chunks" variable controls the maximum number of chunks 
that can be created in a single decision cycle.
.TP
\fBmax_elaborations\fR [positive integer]
The "max_elaborations" variable controls the maximum number of
elaborations allowed in a single decision cycle.
.TP
\fBo_support_mode\fR [0|1|2]
The "o_support_mode" variable is used to control the
way o-support calculations are done for the agent.
.TP
\fBsave_backtraces\fR (boolean)
The "save_backtraces" variable enables and disables the saving
of backtracing information.  It must be on for the \fIexplain-backtraces\fR
command to provide backtracing information.
.TP
\fBwarnings\fR (boolean)
This "warnings" variable enables and disables the printing of 
warning messages.
.PP
.RE

.SH SEE ALSO
\fBset\fR \fB attribute_preferences_mode\fR \fBdefault_wme_depth\fR 
\fBmax_chunks\fR \fBmax_elaborations\fR \fBo_support_mode\fR
\fBsave_backtraces\fR \fBwarnings\fR

