## set tsiConfig(debug) to 1 when debugging, 0 when not
set tsiConfig(debug) 0

## if expertise is 1, it is the full interface,
## if 0, it is for very very first time users
set tsiConfig(expertise) 1

if {$tcl_version >= 8.0} {
	 if {$tcl_platform(platform) == {unix}} {
		  set tsiConfig(normalFont) {courier 11 normal}
		  set tsiConfig(boldFont)   {courier 11 bold}
		  set tsiConfig(italicFont) {courier 11 italic}
		  set tsiConfig(helpFont)   {courier 11 bold}
		  set tsiConfig(searchTextFont) {courier 11 normal}
		  set tsiConfig(searchButtonsFont) {system 11}
	 } else {
		  set tsiConfig(normalFont) {courier 10 normal}
		  set tsiConfig(boldFont)   {courier 10 bold}
		  set tsiConfig(italicFont) {courier 10 italic}
		  set tsiConfig(helpFont)   {courier 10 bold}
		  set tsiConfig(searchTextFont) {courier 10 normal}
		  set tsiConfig(searchButtonsFont) {system 10}
	 }   
} else {
	 if {$tcl_platform(platform) == {unix}} {
		  set tsiConfig(normalFont) {*-Courier-Medium-R-Normal-*-120-*}
		  set tsiConfig(boldFont) {*-Courier-Bold-R-Normal-*-120-*}
		  set tsiConfig(italicFont) {*-Courier-Medium-O-Normal-*-120-*}
		  set tsiConfig(helpFont) {*-Courier-Bold-O-Normal-*-140-*}
	 } else {
		  set tsiConfig(normalFont) {-*-Courier-Medium-R-Normal--*-120-*-*-*-*-*-*}
		  set tsiConfig(boldFont) {-*-Courier-Bold-R-Normal--*-120-*-*-*-*-*-*}
		  set tsiConfig(italicFont) {-*-Courier-Medium-O-Normal--*-120-*-*-*-*-*-*}
		  set tsiConfig(helpFont) {-*-Courier-Bold-O-Normal--*-120-*-*-*-*-*-*}
	 }
	 set tsiConfig(searchTextFont) {8x13}
	 set tsiConfig(searchButtonsFont) {8x13bold}
}
set tsiConfig(dialogFont) {-adobe-courier-bold-r-normal--18-*-*-*-*}
set tsiConfig(dialogDefaultTextFont) {-adobe-courier-bold-r-normal--18-*-*-*-*}


set tsiConfig(promptConfigure) "-font \{$tsiConfig(boldFont)\}"
set tsiConfig(userTextConfigure) {-underline 1}
set tsiConfig(searchTextConfigure) {-background lightblue}

if {$tcl_version >= 8.0} {
	 set tsiConfig(ControlPanelX) -20
} else {
	 set tsiConfig(ControlPanelX) [expr [winfo screenwidth .] - 460]
}
set tsiConfig(ControlPanelY)  20
set tsiConfig(AgentWindowX)   0
if {$tcl_platform(platform) == {windows}} {
    set tsiConfig(AgentWindowY)   -30
} else {
    set tsiConfig(AgentWindowY)  [expr [winfo screenheight .] - 400]
}
set tsiConfig(AgentWindowDeltaX) 40
set tsiConfig(AgentWindowDeltaY)  0
set tsiConfig(window_count) 0

# max number of user prods to display in pulldownMenu
# zero means don't limit it at all
set tsiConfig(maxUserProdMenu) 0
